require 'spec_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to specify the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator.  If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails.  There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.
#
# Compared to earlier versions of this generator, there is very limited use of
# stubs and message expectations in this spec.  Stubs are only used when there
# is no simpler way to get a handle on the object needed for the example.
# Message expectations are only used when there is no simpler way to specify
# that an instance is receiving a specific message.

describe BeesController do

  # This should return the minimal set of attributes required to create a valid
  # Bee. As you add validations to Bee, be sure to
  # update the return value of this method accordingly.
  def valid_attributes
    {}
  end

  describe "GET index" do
    it "assigns all bees as @bees" do
      bee = Bee.create! valid_attributes
      get :index
      assigns(:bees).should eq([bee])
    end
  end

  describe "GET show" do
    it "assigns the requested bee as @bee" do
      bee = Bee.create! valid_attributes
      get :show, :id => bee.id.to_s
      assigns(:bee).should eq(bee)
    end
  end

  describe "GET new" do
    it "assigns a new bee as @bee" do
      get :new
      assigns(:bee).should be_a_new(Bee)
    end
  end

  describe "GET edit" do
    it "assigns the requested bee as @bee" do
      bee = Bee.create! valid_attributes
      get :edit, :id => bee.id.to_s
      assigns(:bee).should eq(bee)
    end
  end

  describe "POST create" do
    describe "with valid params" do
      it "creates a new Bee" do
        expect {
          post :create, :bee => valid_attributes
        }.to change(Bee, :count).by(1)
      end

      it "assigns a newly created bee as @bee" do
        post :create, :bee => valid_attributes
        assigns(:bee).should be_a(Bee)
        assigns(:bee).should be_persisted
      end

      it "redirects to the created bee" do
        post :create, :bee => valid_attributes
        response.should redirect_to(Bee.last)
      end
    end

    describe "with invalid params" do
      it "assigns a newly created but unsaved bee as @bee" do
        # Trigger the behavior that occurs when invalid params are submitted
        Bee.any_instance.stub(:save).and_return(false)
        post :create, :bee => {}
        assigns(:bee).should be_a_new(Bee)
      end

      it "re-renders the 'new' template" do
        # Trigger the behavior that occurs when invalid params are submitted
        Bee.any_instance.stub(:save).and_return(false)
        post :create, :bee => {}
        response.should render_template("new")
      end
    end
  end

  describe "PUT update" do
    describe "with valid params" do
      it "updates the requested bee" do
        bee = Bee.create! valid_attributes
        # Assuming there are no other bees in the database, this
        # specifies that the Bee created on the previous line
        # receives the :update_attributes message with whatever params are
        # submitted in the request.
        Bee.any_instance.should_receive(:update_attributes).with({'these' => 'params'})
        put :update, :id => bee.id, :bee => {'these' => 'params'}
      end

      it "assigns the requested bee as @bee" do
        bee = Bee.create! valid_attributes
        put :update, :id => bee.id, :bee => valid_attributes
        assigns(:bee).should eq(bee)
      end

      it "redirects to the bee" do
        bee = Bee.create! valid_attributes
        put :update, :id => bee.id, :bee => valid_attributes
        response.should redirect_to(bee)
      end
    end

    describe "with invalid params" do
      it "assigns the bee as @bee" do
        bee = Bee.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        Bee.any_instance.stub(:save).and_return(false)
        put :update, :id => bee.id.to_s, :bee => {}
        assigns(:bee).should eq(bee)
      end

      it "re-renders the 'edit' template" do
        bee = Bee.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        Bee.any_instance.stub(:save).and_return(false)
        put :update, :id => bee.id.to_s, :bee => {}
        response.should render_template("edit")
      end
    end
  end

  describe "DELETE destroy" do
    it "destroys the requested bee" do
      bee = Bee.create! valid_attributes
      expect {
        delete :destroy, :id => bee.id.to_s
      }.to change(Bee, :count).by(-1)
    end

    it "redirects to the bees list" do
      bee = Bee.create! valid_attributes
      delete :destroy, :id => bee.id.to_s
      response.should redirect_to(bees_url)
    end
  end

end
